#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
				sendPrivate(p, "!start !stop");
			}
		case OP_Player:
			{	// Player-level commands
				sendPrivate(p, "!about !status");
			}
		}

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
			if (c->checkParam("owner") || c->checkParam("all"))
			{
			}
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if (c->checkParam("sop") || c->checkParam("all"))
			{
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->checkParam("smod") || c->checkParam("all"))
			{
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->checkParam("mod") || c->checkParam("all"))
			{
			}
		}
	case OP_Limited:
		{	// Limited-level commands
			if (c->checkParam("start"))
			{
				sendPrivate(p, "!start");
				sendPrivate(p, "Starts warping");
			}
			else if (c->checkParam("stop"))
			{
				sendPrivate(p, "!stop");
				sendPrivate(p, "Stops warping");
			}
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
			if (c->check("start"))
			{
				if (Enabled)
					sendPrivate(p, "Already started");
				else
					sendPrivate(p, "Started warping players");

				Enabled = true;
			}
			else if (c->check("stop"))
			{
				if (!Enabled)
					sendPrivate(p, "Already stopped");
				else
					sendPrivate(p, "Stopped warping players");

				Enabled = false;
			}
		}
	case OP_Player:
		{	// Player-level commands
			if (c->check("about"))
			{
				String s;
				s = "\"TM Baw\" 1.2 compiled on ";
				s += __DATE__;
				s += " ";
				s += __TIME__;

				sendPrivate(p, s.msg);

				s = "DLL core version: ";
				s += (int)CORE_MAJOR_VERSION;
				s += ".";
				s += (int)CORE_MINOR_VERSION;

				sendPrivate(p, s.msg);

				sendPrivate(p, "Made by SOS(aarkesos@subdimension.com) in cooperation with Continuum Central Union(ccu.continuum-central.com). Well not really, but they deserve the ad :p");
			}
			else if (c->check("status"))
			{
				String s;
				s = "The bot has ";
				s += Warps.total;
				s += " warp locations";

				sendPrivate(p, s.msg);

				if (Enabled)
					sendPrivate(p, "Bot is enabled");
				else
					sendPrivate(p, "Bot is disabled");
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
